<?php
/**
 * Host auto logout manager class.
 *
 * PHP version 5
 *
 * @category HostAutoLogoutManager
 * @package  FOGProject
 * @author   Tom Elliott <tommygunsster@gmail.com>
 * @license  http://opensource.org/licenses/gpl-3.0 GPLv3
 * @link     https://fogproject.org
 */
/**
 * Host auto logout manager class.
 *
 * @category HostAutoLogoutManager
 * @package  FOGProject
 * @author   Tom Elliott <tommygunsster@gmail.com>
 * @license  http://opensource.org/licenses/gpl-3.0 GPLv3
 * @link     https://fogproject.org
 */
class HostAutoLogoutManager extends FOGManagerController
{
    /**
     * The base table name.
     *
     * @var string
     */
    public $tablename = 'hostAutoLogout';
    /**
     * Install our table.
     *
     * @return bool
     */
    public function install()
    {
        $this->uninstall();
        $sql = Schema::createTable(
            $this->tablename,
            true,
            array(
                'hID',
                'hText',
                'hUser',
                'hTime',
                'hIP'
            ),
            array(
                'INTEGER',
                'VARCHAR(255)',
                'VARCHAR(40)',
                'TIMESTAMP',
                'VARCHAR(50)'
            ),
            array(
                false,
                false,
                false,
                false,
                false
            ),
            array(
                false,
                false,
                false,
                'CURRENT_TIMESTAMP',
                false
            ),
            array(
                'hID',
                array(
                    'hUser',
                    'hTime'
                )
            ),
            'InnoDB',
            'utf8',
            'hID',
            'hID'
        );
        return self::$DB->query($sql);
    }
}
